
import java.io.*;

public class Main
{
   public static void main(String [] args)
   {
      // Create a PatternFilter array.

      PatternFilter [] _rgPat = new PatternFilter [ args.length ];

      InputStream is = System.in;

      // For each pattern specified on the command line,
      // create a StringPatternFilter instance for that
      // pattern and link them into a chain.

      for (int i = 0; i < args.length; i++)
      {
         is = _rgPat[i] = new StringPatternFilter(is, args[i]);
      }

      // When finished we have something that looks like:
      //         +---+  +---+     +---+
      //    is --|-o |--|-o |-...-|-o |----o System.in
      //         +---+  +---+     +---+
      // connecting _is_ all the way back to the original
      // input stream _System.in_.

      try
      {
         int c;

         // Read a character, write a character...

         while ((c = is.read()) > -1)
         {
            System.out.write(c);
         }
      }
      catch (Exception e)
      {
         // Die...

         e.printStackTrace();

         System.exit(-1);
      }
   }
}
