
import java.io.*;

abstract public class PatternFilter extends FilterInputStream
{
   public PatternFilter(InputStream is)
   {
      super(is);
   }

   abstract protected boolean match() throws IOException;

   public int read() throws IOException
   {
      // Look ahead in the input stream for a match --
      // throw JunkMailException if one is found.

      if (match()) throw new JunkMailException(toString());

      return super.read();
   }
}
