
import java.io.*;

public class StringPatternFilter extends PatternFilter
{
   private String _str = null;

   public StringPatternFilter(InputStream is, String str)
   {
      super(is);

      _str = str;
   }

   protected boolean match() throws IOException
   {
      // Read in bytes, convert them into a String, and compare
      // the String with the stored String.

      int l = _str.length();

      byte [] rgb = new byte [l];

      char [] rgc = new char [l];

      in.mark(l);

      in.read(rgb);

      convertByteToChar(rgb, rgc);

      String str = new String(rgc);

      if (str.equals(_str)) return true;

      in.reset();

      return false;
   }

   private void convertByteToChar(byte [] rgb, char [] rgc)
   {
      // Convert an array of bytes into an array of characters.
      // Do it as simply as possible -- in this case, just like it was
      // done in Java 1.0.  Put each byte from the byte array into
      // the low order byte of each two byte character in the char
      // array.  The high order byte is always 0x00.  This isn't great
      // bute since most electronic mail is still 8-bit ASCII, it
      // works.

      // Luckily, Java 1.1 provides us with many more possibilities.

      if (rgb.length != rgc.length)
      {
         throw new IllegalArgumentException("array sizes aren't equal");
      }

      for (int i = 0; i < rgc.length ; i++)
      {
         rgc[i] = (char)(rgb[i] & 0xFF);
      }
   }

   public String toString()
   {
      return _str;
   }
}
